package cz.zcu.fav.kiv.mjakubas.saf.config.configs;

import org.jetbrains.annotations.NotNull;

import java.net.Authenticator;

/**
 * Represents a parsed net config of application and contains all back-end queries definition.
 */
public record RequestConfig(@NotNull String address, @NotNull Authenticator authenticator) {

    public static final String ABSENCE_ENTITIES_QUERY = "/absences";
    public static final String BUILDING_ENTITIES_QUERY = "/buildings";
    public static final String CLASSES_ENTITIES_QUERY = "/classes";
    public static final String EVALUATIONS_ENTITIES_QUERY = "/evaluations";
    public static final String ROOMS_ENTITIES_QUERY = "/rooms";
    public static final String SCHEDULEACTIONS_ENTITIES_QUERY = "/scheduleactions";
    public static final String SCHEDULEACTIONDATES_ENTITIES_QUERY = "/scheduleactionsdates";
    public static final String SCHOOLDAYS_ENTITIES_QUERY = "/schooldays";
    public static final String SCHOOLHOURS_ENTITIES_QUERY = "/schoolhours";
    public static final String STUDENTS_ENTITIES_QUERY = "/students";
    public static final String STUDENTSSUBJECTS_ENTITIES_QUERY = "/studentssubjects";
    public static final String SUBJECTS_ENTITIES_QUERY = "/subjects";
    public static final String SUBJECTLISTS_ENTITIES_QUERY = "/subjectlists";
    public static final String TEACHERS_ENTITIES_QUERY = "/teachers";

    /* -- */

    public static final String SCHEDULEACTION_QUERY = "/scheduleaction";

    public static final String ID_QUERY = "/id";
    public static final String STUDENT_QUERY = "/student";
    public static final String TEACHER_QUERY = "/teacher";

    public static final String SUBJECT_QUERY = "/subject";

    public static final String NAME_QUERY = "/name";
    public static final String SCHEDULEACTIONDATE_QUERY = "/scheduleactionsdate";
    public static final String ROOM_QUERY = "/room";
    public static final String STUDENTSSUBJECT_QUERY = "/studentssubject";
    public static final String CAPACITY_QUERY = "/capacity";
    public static final String BUILDING_QUERY = "/building";
    public static final String SUBSTITUTION_QUERY = "/substitutions";
    public static final String DATE_QUERY = "/date";
    public static final String SUBJECTLIST_QUERY = "/subjectlist";
    public static final String CLASS_QUERY = "/class";

    /* -- */

    public static final String ADD_QUERY = "/add";
    public static final String REMOVE_QUERY = "/remove";
    public static final String AVERAGE_QUERY = "/average";
}
