package cz.zcu.fav.kiv.mjakubas.saf.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;

/**
 * Describes a common method for identifying entity.
 */
public abstract class ASimpleEntity {

    /**
     * Gets simple identifier.
     *
     * @return simple identifier
     */
    @JsonIgnore
    public abstract int getID();

    @JsonIgnore
    public String getIdentifier() {
        return String.format("[%s] ", getID()) + getSimpleIdentifier();
    }

    @JsonIgnore
    public abstract String getSimpleIdentifier();

    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof ASimpleEntity otherEntity))
            return false;

        int thisIndex = this.getID();
        int otherIndex = otherEntity.getID();
        return thisIndex == otherIndex;
    }
}
