package cz.zcu.fav.kiv.mjakubas.saf.entity;

import com.fasterxml.jackson.annotation.JsonInclude;

/**
 * Represents Building entity from a backend of school agenda.
 */
@JsonInclude(JsonInclude.Include.NON_DEFAULT)
public final class Building extends ASimpleEntity {

    private int idBuildings;
    private String buildingName;
    private Room[] rooms;

    // constructors

    /**
     * Instantiates new empty Building entity.
     */
    public Building() {
    }

    /**
     * Instantiates new Building entity with all its fields.
     *
     * @param idBuildings  building id
     * @param buildingName building name
     * @param rooms        building rooms
     */
    public Building(int idBuildings, String buildingName, Room[] rooms) {
        this.idBuildings = idBuildings;
        this.buildingName = buildingName;
        this.rooms = rooms;
    }

    // override

    @Override
    public int getID() {
        return idBuildings;
    }

    @Override
    public String getSimpleIdentifier() {
        return String.format("%s", buildingName);
    }

    @Override
    public String toString() {
        return getIdentifier();
    }

    // get

    /**
     * Get building id.
     *
     * @return building id
     */
    public int getIdBuildings() {
        return idBuildings;
    }

    /**
     * Get building name.
     *
     * @return building name
     */
    public String getBuildingName() {
        return buildingName;
    }

    /**
     * Get building rooms.
     *
     * @return building rooms
     */
    public Room[] getRooms() {
        return rooms;
    }

    // set

    /**
     * Set building id.
     *
     * @param idBuildings building id
     */
    public void setIdBuildings(int idBuildings) {
        this.idBuildings = idBuildings;
    }

    /**
     * Set building name.
     *
     * @param buildingName building name
     */
    public void setBuildingName(String buildingName) {
        this.buildingName = buildingName;
    }

    /**
     * Set building rooms.
     *
     * @param roomEntities building rooms
     */
    public void setRooms(Room[] roomEntities) {
        this.rooms = roomEntities;
    }
}
