package cz.zcu.fav.kiv.mjakubas.saf.entity;

import com.fasterxml.jackson.annotation.JsonInclude;

/**
 * Represents schedule action date entity from a backend of school agenda.
 */
@JsonInclude(JsonInclude.Include.NON_DEFAULT)
public final class ScheduleActionDate extends ASimpleEntity {

    private int idScheduleactionsdates;
    private String date;
    private String theme;
    private int idScheduleactions;
    private int idTeachers;
    private int idRooms;
    private int idSchooldays;
    private int idSchoolhours;

    private Absence[] absences;

    private ScheduleAction scheduleaction;
    private Teacher teacher;
    private Room room;
    private SchoolDay schoolDay;
    private SchoolHour schoolHour;

    // constructor

    /**
     * Instantiates new {@link ScheduleActionDate}.
     */
    public ScheduleActionDate() {
    }

    /**
     * Instantiates new {@link ScheduleActionDate} with all its attributes.
     *
     * @param idScheduleactionsdates ID of {@link ScheduleActionDate}
     * @param date                   date of {@link ScheduleActionDate}
     * @param theme                  theme of {@link ScheduleActionDate}
     * @param idScheduleactions      ID of {@link ScheduleAction} of {@link ScheduleActionDate}
     * @param idTeachers             ID of {@link Teacher} of {@link ScheduleActionDate}
     * @param idRooms                ID of {@link  Room} of of {@link ScheduleActionDate}
     * @param idSchooldays           ID of {@link SchoolDay} of {@link ScheduleActionDate}
     * @param idSchoolhours          ID of {@link SchoolHour} of {@link ScheduleActionDate}
     * @param absences               {@link Absence} entities of {@link ScheduleActionDate}
     */
    public ScheduleActionDate(int idScheduleactionsdates, String date, String theme, int idScheduleactions, int idTeachers, int idRooms, int idSchooldays, int idSchoolhours, Absence[] absences) {
        this.idScheduleactionsdates = idScheduleactionsdates;
        this.date = date;
        this.theme = theme;
        this.idScheduleactions = idScheduleactions;
        this.idTeachers = idTeachers;
        this.idRooms = idRooms;
        this.idSchooldays = idSchooldays;
        this.idSchoolhours = idSchoolhours;
        this.absences = absences;
    }

    // override

    @Override
    public int getID() {
        return idScheduleactionsdates;
    }

    @Override
    public String getSimpleIdentifier() {
        return String.format("%s %s", date, theme);
    }

    @Override
    public String toString() {
        return getIdentifier();
    }

    // get

    /**
     * Get schedule action date id.
     *
     * @return schedule action date id
     */
    public int getIdScheduleactionsdates() {
        return idScheduleactionsdates;
    }

    /**
     * Get schedule action date date.
     *
     * @return schedule action date date
     */
    public String getDate() {
        return date;
    }

    /**
     * Get schedule action date theme.
     *
     * @return schedule action date theme
     */
    public String getTheme() {
        return theme;
    }

    /**
     * Get schedule action id.
     *
     * @return schedule action id
     */
    public int getIdScheduleactions() {
        return idScheduleactions;
    }

    /**
     * Get schedule action teacher id.
     *
     * @return schedule action teacher id
     */
    public int getIdTeachers() {
        return idTeachers;
    }

    /**
     * Get schedule action date room id.
     *
     * @return schedule action date room id
     */
    public int getIdRooms() {
        return idRooms;
    }

    /**
     * Get schedule action date school day id.
     *
     * @return schedule action date school day id
     */
    public int getIdSchooldays() {
        return idSchooldays;
    }

    /**
     * Get schedule action school hour id.
     *
     * @return schedule action school hour id
     */
    public int getIdSchoolhours() {
        return idSchoolhours;
    }

    /**
     * Get schedule action date absences.
     *
     * @return schedule action date absences
     */
    public Absence[] getAbsences() {
        return absences;
    }

    /**
     * Get schedule action date teacher.
     *
     * @return schedule action date teacher
     */
    public Teacher getTeacher() {
        return teacher;
    }

    /**
     * Get schedule action date room.
     *
     * @return schedule action date room
     */
    public Room getRoom() {
        return room;
    }

    /**
     * Get schedule action date school day.
     *
     * @return schedule action date school day
     */
    public SchoolDay getSchoolDay() {
        return schoolDay;
    }

    /**
     * Get schedule action date school hour.
     *
     * @return schedule action date school hour
     */
    public SchoolHour getSchoolHour() {
        return schoolHour;
    }

    /**
     * Get schedule action.
     *
     * @return schedule action
     */
    public ScheduleAction getScheduleaction() {
        return scheduleaction;
    }

    // set

    /**
     * Set schedule action date teacher.
     *
     * @param teacher schedule action date teacher
     */
    public void setTeacher(Teacher teacher) {
        this.teacher = teacher;
    }

    /**
     * Set schedule action date room.
     *
     * @param room schedule action date room
     */
    public void setRoom(Room room) {
        this.room = room;
    }

    /**
     * Set schedule action date school day.
     *
     * @param schoolDay schedule action date school day
     */
    public void setSchoolDay(SchoolDay schoolDay) {
        this.schoolDay = schoolDay;
    }

    /**
     * Set schedule action date school hour.
     *
     * @param schoolHour schedule action date school hour
     */
    public void setSchoolHour(SchoolHour schoolHour) {
        this.schoolHour = schoolHour;
    }

    /**
     * Set schedule action date schedule action.
     *
     * @param scheduleaction schedule action date schedule action
     */
    public void setScheduleaction(ScheduleAction scheduleaction) {
        this.scheduleaction = scheduleaction;
    }

    /**
     * Set schedule action date id.
     *
     * @param idScheduleactionsdates schedule action date id
     */
    public void setIdScheduleactionsdates(int idScheduleactionsdates) {
        this.idScheduleactionsdates = idScheduleactionsdates;
    }

    /**
     * Set schedule action date date.
     *
     * @param date schedule action date date
     */
    public void setDate(String date) {
        this.date = date;
    }

    /**
     * Set schedule action date theme.
     *
     * @param theme schedule action date theme
     */
    public void setTheme(String theme) {
        this.theme = theme;
    }

    /**
     * Set schedule action id.
     *
     * @param idScheduleactions schedule action date id
     */
    public void setIdScheduleactions(int idScheduleactions) {
        this.idScheduleactions = idScheduleactions;
    }

    /**
     * Set schedule action date teacher id.
     *
     * @param idTeachers schedule action date teacher id
     */
    public void setIdTeachers(int idTeachers) {
        this.idTeachers = idTeachers;
    }

    /**
     * Set schedule action date room id.
     *
     * @param idRooms schedule action date room id
     */
    public void setIdRooms(int idRooms) {
        this.idRooms = idRooms;
    }

    /**
     * Set schedule action date school day id.
     *
     * @param idSchooldays schedule action date school day id
     */
    public void setIdSchooldays(int idSchooldays) {
        this.idSchooldays = idSchooldays;
    }

    /**
     * Set schedule action date school hour id.
     *
     * @param idSchoolhours schedule action date school hour id
     */
    public void setIdSchoolhours(int idSchoolhours) {
        this.idSchoolhours = idSchoolhours;
    }

    /**
     * Set schedule action date absence.
     *
     * @param absences schedule action date absence
     */
    public void setAbsences(Absence[] absences) {
        this.absences = absences;
    }
}
