package cz.zcu.fav.kiv.mjakubas.saf.entity;

import com.fasterxml.jackson.annotation.JsonInclude;

/**
 * Represents a School Day entity implementation for frontend of school agenda.
 */
@JsonInclude(JsonInclude.Include.NON_DEFAULT)
public final class SchoolDay extends ASimpleEntity {

    private int idSchooldays;
    private String schooldayName;

    private ScheduleAction[] scheduleactions;
    private ScheduleActionDate[] scheduleactiondates;

    // constructor

    /**
     * Instantiates new {@link SchoolDay}.
     */
    public SchoolDay() {
    }

    /**
     * Instantiates new {@link SchoolDay} with all its attributes.
     *
     * @param idSchooldays        ID of {@link SchoolDay}
     * @param schooldayName       name of {@link SchoolDay}
     * @param scheduleactions     {@link ScheduleAction} entities of {@link SchoolDay}
     * @param scheduleactiondates {@link ScheduleActionDate} entities of {@link SchoolDay}
     */
    public SchoolDay(int idSchooldays, String schooldayName, ScheduleAction[] scheduleactions, ScheduleActionDate[] scheduleactiondates) {
        this.idSchooldays = idSchooldays;
        this.schooldayName = schooldayName;
        this.scheduleactions = scheduleactions;
        this.scheduleactiondates = scheduleactiondates;
    }

    // override

    @Override
    public int getID() {
        return idSchooldays;
    }

    @Override
    public String getSimpleIdentifier() {
        return schooldayName;
    }

    @Override
    public String toString() {
        return getIdentifier();
    }

    // get

    /**
     * Get school day id.
     *
     * @return school day id
     */
    public int getIdSchooldays() {
        return idSchooldays;
    }

    /**
     * Get school day name.
     *
     * @return school day name
     */
    public String getSchooldayName() {
        return schooldayName;
    }

    /**
     * Get school day schedule action.
     *
     * @return school day schedule action
     */
    public ScheduleAction[] getScheduleactions() {
        return scheduleactions;
    }

    /**
     * Get school day schedule action date.
     *
     * @return school day schedule action date
     */
    public ScheduleActionDate[] getScheduleactiondates() {
        return scheduleactiondates;
    }

    // set

    /**
     * Set school day id.
     *
     * @param idSchooldays school day id
     */
    public void setIdSchooldays(int idSchooldays) {
        this.idSchooldays = idSchooldays;
    }

    /**
     * Set school day name.
     *
     * @param schooldayName school day name
     */
    public void setSchooldayName(String schooldayName) {
        this.schooldayName = schooldayName;
    }

    /**
     * Set school day schedule action.
     *
     * @param scheduleactions school day schedule action
     */
    public void setScheduleactions(ScheduleAction[] scheduleactions) {
        this.scheduleactions = scheduleactions;
    }

    /**
     * Set school day schedule action date.
     *
     * @param scheduleactiondates school day schedule action date
     */
    public void setScheduleactiondates(ScheduleActionDate[] scheduleactiondates) {
        this.scheduleactiondates = scheduleactiondates;
    }
}
