package cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.entities;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.RequestConfig;
import cz.zcu.fav.kiv.mjakubas.saf.entity.Building;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform.AForm;
import org.jetbrains.annotations.NotNull;

/**
 * Fetches and manages {@link Building} connection between front-end and back-end.
 */
public class BuildingEntityController extends AEntityController<Building> {

    // constructor

    /**
     * Instantiates new {@link AEntityController} of certain entity.
     */
    public BuildingEntityController(
            @NotNull AForm<Building> entityForm,
            @NotNull EntitiesController entitiesController) {
        super(entityForm, entitiesController);
    }

    // override

    @Override
    protected String getBaseAddress() {
        return RequestConfig.BUILDING_ENTITIES_QUERY;
    }

    @Override
    protected String getAdditionalAddress() {
        return null;
    }

    @Override
    protected Class<Building> getEntityClass() {
        return Building.class;
    }

    @Override
    protected void fetchAdditionalData() throws FetchException {

    }
}
