package cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.entities;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.RequestConfig;
import cz.zcu.fav.kiv.mjakubas.saf.entity.SchoolClass;
import cz.zcu.fav.kiv.mjakubas.saf.entity.Student;
import cz.zcu.fav.kiv.mjakubas.saf.entity.Subject;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform.AForm;
import org.jetbrains.annotations.NotNull;

import java.util.Arrays;
import java.util.List;

/**
 * Fetches and manages {@link Student} connection between front-end and back-end.
 */
public class StudentEntityController extends AEntityController<Student> {

    // constructor

    /**
     * Instantiates new {@link AEntityController} of certain entity.
     */
    public StudentEntityController(
            @NotNull AForm<Student> entityForm,
            @NotNull EntitiesController entitiesController) {
        super(entityForm, entitiesController);
    }

    // override

    @Override
    protected String getBaseAddress() {
        return RequestConfig.STUDENTS_ENTITIES_QUERY;
    }

    @Override
    protected String getAdditionalAddress() {
        return RequestConfig.SUBJECT_QUERY;
    }

    @Override
    protected Class<Student> getEntityClass() {
        return Student.class;
    }

    @Override
    protected void fetchAdditionalData() throws FetchException {
        try {
            List<SchoolClass> fetchedClasses = entitiesController.getClassEntityController().getAllFetchedEntities();
            /*
            for (Student s : fetchedEntities) {
                SchoolClass sClass = fetchedClasses.stream().filter(classEntity -> {
                    for (Student classStudent : classEntity.getStudents()) {
                        if (classStudent.getID() == s.getID()) {
                            return true;
                        }
                    }
                    return false;
                }).toList().get(0);
                s.setClassesEntity(sClass);
            }
             */

            for (Student s : fetchedEntities) {
                for (SchoolClass sClass : fetchedClasses) {
                    List<Student> h = Arrays.stream(sClass.getStudents()).filter(x -> x.getID() == s.getID()).toList();
                    if (h.size() != 0) {
                        s.setClassesEntity(sClass);
                    }
                }
            }

            List<Subject> fetchedSubjects = entitiesController.getSubjectEntityController().getAllFetchedEntities();
            for (Student s : fetchedEntities) {
                for (int i = 0; i < s.getSubjects().length; i++) {
                    int j = i;
                    s.getSubjects()[i] =
                            fetchedSubjects.stream().filter(x -> x.getID() == s.getSubjects()[j].getID()).toList().get(0);
                }
            }
        } catch (FetchException e) {
            throw new RuntimeException(e);
        }
    }
}
