package cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.entities;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.RequestConfig;
import cz.zcu.fav.kiv.mjakubas.saf.entity.*;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform.AForm;
import org.jetbrains.annotations.NotNull;

import java.util.Arrays;
import java.util.List;

/**
 * Fetches and manages {@link Subject} connection between front-end and back-end.
 */
public class SubjectEntityController extends AEntityController<Subject> {

    // constructor

    /**
     * Instantiates new {@link AEntityController} of certain entity.
     */
    public SubjectEntityController(
            @NotNull AForm<Subject> entityForm,
            @NotNull EntitiesController entitiesController) {
        super(entityForm, entitiesController);
    }

    // override

    @Override
    protected String getBaseAddress() {
        return RequestConfig.SUBJECTS_ENTITIES_QUERY;
    }

    @Override
    protected String getAdditionalAddress() {
        return null;
    }

    @Override
    protected Class<Subject> getEntityClass() {
        return Subject.class;
    }

    @Override
    protected void fetchAdditionalData() throws FetchException {
        List<Teacher> teacherList =
                EntitiesController.getEntitiesController().getTeacherEntityController().getAllFetchedEntities();

        List<SubjectList> subjectListList =
                EntitiesController.getEntitiesController().getSubjectListEntityController().getAllFetchedEntities();

        for (Subject subject : fetchedEntities) {
            for (Teacher teacher : teacherList) {
                Subject[] subjects = teacher.getSubjects();
                Subject[] f =
                        Arrays.stream(subjects).filter(x -> x.getID() == subject.getID()).toList().toArray(new Subject[0]);
                if (f.length != 0) {
                    subject.setTeacher(teacher);
                    break;
                }
            }

            for (SubjectList subjectList : subjectListList) {
                Subject[] subjects = subjectList.getSubjects();
                Subject[] f =
                        Arrays.stream(subjects).filter(x -> x.getID() == subject.getID()).toList().toArray(new Subject[0]);
                if (f.length != 0) {
                    subject.setSubjectlist(subjectList);
                    break;
                }
            }
        }
    }
}
