package cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform;

import com.dlsc.formsfx.model.structure.Field;
import com.dlsc.formsfx.model.structure.Form;
import com.dlsc.formsfx.model.structure.Group;
import com.dlsc.formsfx.view.renderer.FormRenderer;
import cz.zcu.fav.kiv.mjakubas.saf.entity.SchoolDay;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.i18n.I18N;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nmodel.IModel;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nmodel.SchoolDayModel;
import javafx.scene.layout.Pane;
import org.jetbrains.annotations.NotNull;

/**
 * Represent all possible forms of {@link SchoolDay} entity.
 */
public class SchoolDayForm extends AForm<SchoolDay> {
    @Override
    protected AEntityController<?> getEntityController() {
        return EntitiesController.getEntitiesController().getSchoolDayEntityController();
    }

    @Override
    protected Form createPostForm(IModel<SchoolDay> entityModel) {
        SchoolDayModel model = (SchoolDayModel) entityModel;
        return Form.of(
                Group.of(
                        Field.ofStringType(model.schoolDayNameProperty())
                                .label("form.label.school-day-name")
                                .required("form.required")
                                .placeholder("form.placeholder.school-day-name")
                )
        ).i18n(I18N.getLocalizationTool().getResourceBundleService());
    }

    @Override
    protected Pane createPostPane(Form postForm) {
        return new FormRenderer(postForm);
    }

    @Override
    protected Form createEditablePutForm(IModel<SchoolDay> entityModel) {
        SchoolDayModel model = (SchoolDayModel) entityModel;
        return Form.of(
                Group.of(
                        Field.ofIntegerType(model.schoolDayIDProperty())
                                .label("form.label.id")
                                .editable(false),
                        Field.ofStringType(model.schoolDayNameProperty())
                                .label("form.label.school-day-name")
                                .required("form.required")
                                .placeholder("form.placeholder.school-day-name")
                )
        ).i18n(I18N.getLocalizationTool().getResourceBundleService());
    }

    @Override
    protected Pane createEditablePutPane(Form editablePutForm) {
        return new FormRenderer(editablePutForm);
    }

    @Override
    protected Form createAdditionalPutForm(IModel<?> entityModel) {
        return null;
    }

    @Override
    protected Pane createNonEditablePutPane(Form nonEditablePutForm) {
        return null;
    }

    @Override
    protected Form createAdditionalDeletePutForm(IModel<?> entityModel) {
        return null;
    }

    @Override
    protected Pane createNonEditableDeletePutPane(Form nonEditablePutForm) {
        return null;
    }

    @Override
    protected IModel<SchoolDay> createEmptyModel() {
        return new SchoolDayModel();
    }

    @Override
    protected IModel<SchoolDay> createEntityModel(@NotNull SchoolDay entity) {
        IModel<SchoolDay> schoolDayModel = new SchoolDayModel();
        schoolDayModel.importEntity(entity);
        return schoolDayModel;
    }

    @Override
    protected IModel<?> createAdditionalModel() {
        return null;
    }

    @Override
    protected Object getAdditionalEntity(IModel<SchoolDay> additionalModel) {
        return null;
    }
}
