package cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform;

import com.dlsc.formsfx.model.structure.Field;
import com.dlsc.formsfx.model.structure.Form;
import com.dlsc.formsfx.model.structure.Group;
import com.dlsc.formsfx.view.renderer.FormRenderer;
import cz.zcu.fav.kiv.mjakubas.saf.entity.SubjectList;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.i18n.I18N;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nmodel.IModel;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nmodel.SubjectListModel;
import javafx.scene.layout.Pane;
import org.jetbrains.annotations.NotNull;

/**
 * Represent all possible forms of {@link SubjectList} entity.
 */
public class SubjectListForm extends AForm<SubjectList> {
    @Override
    protected AEntityController<?> getEntityController() {
        return EntitiesController.getEntitiesController().getSubjectListEntityController();
    }

    @Override
    protected Form createPostForm(IModel<SubjectList> entityModel) {
        SubjectListModel model = (SubjectListModel) entityModel;
        return Form.of(
                Group.of(
                        Field.ofStringType(model.subjectNameProperty())
                                .label("form.label.subject-name")
                                .required("form.required")
                                .placeholder("form.placeholder.subject-name")
                )
        ).i18n(I18N.getLocalizationTool().getResourceBundleService());
    }

    @Override
    protected Pane createPostPane(Form postForm) {
        return new FormRenderer(postForm);
    }

    @Override
    protected Form createEditablePutForm(IModel<SubjectList> entityModel) {
        SubjectListModel model = (SubjectListModel) entityModel;
        return Form.of(
                Group.of(
                        Field.ofIntegerType(model.idSubjectListProperty())
                                .label("form.label.id")
                                .editable(false),
                        Field.ofStringType(model.subjectNameProperty())
                                .label("form.label.subject-name")
                                .required("form.required")
                                .placeholder("form.placeholder.subject-name")
                )
        ).i18n(I18N.getLocalizationTool().getResourceBundleService());
    }

    @Override
    protected Pane createEditablePutPane(Form editablePutForm) {
        return new FormRenderer(editablePutForm);
    }

    @Override
    protected Form createAdditionalPutForm(IModel<?> entityModel) {
        return null;
    }

    @Override
    protected Pane createNonEditablePutPane(Form nonEditablePutForm) {
        return null;
    }

    @Override
    protected Form createAdditionalDeletePutForm(IModel<?> entityModel) {
        return null;
    }

    @Override
    protected Pane createNonEditableDeletePutPane(Form nonEditablePutForm) {
        return null;
    }

    @Override
    protected IModel<SubjectList> createEmptyModel() {
        return new SubjectListModel();
    }

    @Override
    protected IModel<SubjectList> createEntityModel(@NotNull SubjectList entity) {
        IModel<SubjectList> subjectModel = new SubjectListModel();
        subjectModel.importEntity(entity);
        return subjectModel;
    }

    @Override
    protected IModel<?> createAdditionalModel() {
        return null;
    }

    @Override
    protected Object getAdditionalEntity(IModel<SubjectList> additionalModel) {
        return null;
    }
}
