package cz.zcu.fav.kiv.mjakubas.saf.gui.form.nmodel;

import cz.zcu.fav.kiv.mjakubas.saf.entity.SchoolDay;
import javafx.beans.property.IntegerProperty;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;

/**
 * Represents a model object of a school day entity.
 */
public class SchoolDayModel implements IModel<SchoolDay> {
    private final IntegerProperty schoolDayID = new SimpleIntegerProperty(0);
    private final StringProperty schoolDayName = new SimpleStringProperty("");

    // override

    @Override
    public void importEntity(SchoolDay entity) {
        this.schoolDayID.set(entity.getID());
        this.schoolDayName.set(entity.getSchooldayName());
    }

    @Override
    public SchoolDay exportEntity() {
        return new SchoolDay(schoolDayID.getValue(), schoolDayName.getValue(), null, null);
    }

    // get

    /**
     * Gets school day entity id.
     *
     * @return school day entity id
     */
    public IntegerProperty schoolDayIDProperty() {
        return schoolDayID;
    }

    /**
     * Gets school day entity name.
     *
     * @return school day entity name
     */
    public StringProperty schoolDayNameProperty() {
        return schoolDayName;
    }
}
