package cz.zcu.fav.kiv.mjakubas.saf.gui.form.nmodel;

import cz.zcu.fav.kiv.mjakubas.saf.entity.SubjectList;
import javafx.beans.property.IntegerProperty;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;

/**
 * Represents a model object of a subject list entity.
 */
public class SubjectListModel implements IModel<SubjectList> {

    private final IntegerProperty idSubjectList = new SimpleIntegerProperty(0);
    private final StringProperty subjectName = new SimpleStringProperty("");

    // override

    @Override
    public void importEntity(SubjectList entity) {
        this.idSubjectList.set(entity.getID());
        this.subjectName.set(entity.getSubjectName());
    }

    @Override
    public SubjectList exportEntity() {
        return new SubjectList(idSubjectList.get(), subjectName.getValue(), null);
    }

    // get

    /**
     * Gets subject list entity id.
     *
     * @return subject list entity id
     */
    public IntegerProperty idSubjectListProperty() {
        return idSubjectList;
    }

    /**
     * Gets subject list entity name.
     *
     * @return subject list entity name
     */
    public StringProperty subjectNameProperty() {
        return subjectName;
    }
}
