package cz.zcu.fav.kiv.mjakubas.saf.gui.view;

import javafx.beans.property.SimpleObjectProperty;

/**
 * Used to cross-reference certain GUI objects.
 */
public class ViewContainer {

    private final SimpleObjectProperty<EntitiesSearchableButtonPane> entitiesPane = new SimpleObjectProperty<>();

    private static final ViewContainer CONTAINER = new ViewContainer();

    private ViewContainer() {
    }

    /**
     * Gets {@link ViewContainer}.
     * @return {@link ViewContainer}
     */
    public static ViewContainer getContainer() {
        return CONTAINER;
    }

    /**
     * Gets {@link EntitiesSearchableButtonPane}
     * @return {@link EntitiesSearchableButtonPane}
     */
    public EntitiesSearchableButtonPane getEntitiesSearchableButtonPane() {
        return entitiesPane.getValue();
    }

    public void setEntitiesSearchableButtonPane(EntitiesSearchableButtonPane entitiesSearchableButtonPane) {
        this.entitiesPane.set(entitiesSearchableButtonPane);
    }
}
