package cz.zcu.fav.kiv.mjakubas.saf.request;

import cz.zcu.fav.kiv.mjakubas.saf.request.basicrequest.HttpResponseResult;
import org.jetbrains.annotations.NotNull;

/**
 * Result of HTTP entity request.
 */
public class EntitiesRequestResult {

    private final HttpResponseResult httpResponseResult;
    private final Object[] deserializedEntities;

    /**
     * Instantiates new request result.
     *
     * @param httpResponseResult response result of http request
     * @param deserializedEntities response entities of http request
     */
    public EntitiesRequestResult(@NotNull HttpResponseResult httpResponseResult, Object[] deserializedEntities) {
        this.httpResponseResult = httpResponseResult;
        this.deserializedEntities = deserializedEntities;
    }

    public HttpResponseResult getHttpResponseResult() {
        return httpResponseResult;
    }

    public Object[] getDeserializedEntities() {
        return deserializedEntities;
    }
}
