package cz.zcu.fav.kiv.mjakubas.saf;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.*;
import org.junit.jupiter.api.*;

import java.net.*;

/**
 * Defines a test config for requests on test localhost server.
 */
public class RequestConfigTestConfigTest {

    private static final String ADDRESS = "http://localhost:8080";
    private static final Authenticator AUTHENTICATOR = new Authenticator() {
        @Override
        protected PasswordAuthentication getPasswordAuthentication() {
            return new PasswordAuthentication("user", "password".toCharArray());
        }
    };

    /**
     * Returns request config for localhost back-end server with a login:
     * username: user
     * password: password
     *
     * @return new Request config suited for testing on localhost.
     */
    public static RequestConfig getTestConfig() {
        return new RequestConfig(ADDRESS, AUTHENTICATOR);
    }

    @Test
    protected void getTestConfigAddress() {
        RequestConfig c = RequestConfigTestConfigTest.getTestConfig();
        Assertions.assertEquals(ADDRESS, c.address());
    }

    @Test
    protected void getTestConfigAuthenticator() {
        RequestConfig c = RequestConfigTestConfigTest.getTestConfig();
        Assertions.assertEquals(AUTHENTICATOR, c.authenticator());
    }
}
