package cz.zcu.fav.kiv.mjakubas.saf.config.configs;

import cz.zcu.fav.kiv.mjakubas.saf.config.ConfigManager;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import java.io.IOException;

/**
 * Represents a request config of application.
 */
class RequestConfigTest {

    RequestConfig requestConfig;

    @BeforeEach
    void setUp() throws IOException {
        requestConfig = ConfigManager.getManager().getRequestConfig();
    }

    //region top

    @Test
    void absences_query() {
        Assertions.assertEquals("/absences", RequestConfig.ABSENCE_ENTITIES_QUERY);
    }

    @Test
    void buildings_query() {
        Assertions.assertEquals("/buildings", RequestConfig.BUILDING_ENTITIES_QUERY);
    }

    @Test
    void classes_query() {
        Assertions.assertEquals("/classes", RequestConfig.CLASSES_ENTITIES_QUERY);
    }

    @Test
    void evaluations_query() {
        Assertions.assertEquals("/evaluations", RequestConfig.EVALUATIONS_ENTITIES_QUERY);
    }

    @Test
    void rooms_query() {
        Assertions.assertEquals("/rooms", RequestConfig.ROOMS_ENTITIES_QUERY);
    }

    @Test
    void scheduleActions_query() {
        Assertions.assertEquals("/scheduleactions", RequestConfig.SCHEDULEACTIONS_ENTITIES_QUERY);
    }

    @Test
    void scheduleActionsDates_query() {
        Assertions.assertEquals("/scheduleactionsdates", RequestConfig.SCHEDULEACTIONDATES_ENTITIES_QUERY);
    }

    @Test
    void schoolDays_query() {
        Assertions.assertEquals("/schooldays", RequestConfig.SCHOOLDAYS_ENTITIES_QUERY);
    }

    @Test
    void schoolHours_query() {
        Assertions.assertEquals("/schoolhours", RequestConfig.SCHOOLHOURS_ENTITIES_QUERY);
    }

    @Test
    void students_query() {
        Assertions.assertEquals("/students", RequestConfig.STUDENTS_ENTITIES_QUERY);
    }

    @Test
    void studentsSubjects_query() {
        Assertions.assertEquals("/studentssubjects", RequestConfig.STUDENTSSUBJECTS_ENTITIES_QUERY);
    }

    @Test
    void subjects_query() {
        Assertions.assertEquals("/subjects", RequestConfig.SUBJECTS_ENTITIES_QUERY);
    }

    @Test
    void subjectLists_query() {
        Assertions.assertEquals("/subjectlists", RequestConfig.SUBJECTLISTS_ENTITIES_QUERY);
    }

    @Test
    void teachers_query() {
        Assertions.assertEquals("/teachers", RequestConfig.TEACHERS_ENTITIES_QUERY);
    }

    //endregion

    @Test
    void scheduleAction_query() {
        Assertions.assertEquals("/scheduleaction", RequestConfig.SCHEDULEACTION_QUERY);
    }

    @Test
    void id_query() {
        Assertions.assertEquals("/id", RequestConfig.ID_QUERY);
    }

    @Test
    void student_query() {
        Assertions.assertEquals("/student", RequestConfig.STUDENT_QUERY);
    }

    @Test
    void teacher_query() {
        Assertions.assertEquals("/teacher", RequestConfig.TEACHER_QUERY);
    }

    @Test
    void subject_query() {
        Assertions.assertEquals("/subject", RequestConfig.SUBJECT_QUERY);
    }

    @Test
    void name_query() {
        Assertions.assertEquals("/name", RequestConfig.NAME_QUERY);
    }

    @Test
    void scheduleActionsDate_query() {
        Assertions.assertEquals("/scheduleactionsdate", RequestConfig.SCHEDULEACTIONDATE_QUERY);
    }

    @Test
    void room_query() {
        Assertions.assertEquals("/room", RequestConfig.ROOM_QUERY);
    }

    @Test
    void studentssubject_query() {
        Assertions.assertEquals("/studentssubject", RequestConfig.STUDENTSSUBJECT_QUERY);
    }

    @Test
    void capacity_query() {
        Assertions.assertEquals("/capacity", RequestConfig.CAPACITY_QUERY);
    }

    @Test
    void building_query() {
        Assertions.assertEquals("/building", RequestConfig.BUILDING_QUERY);
    }

    @Test
    void substitution_query() {
        Assertions.assertEquals("/substitutions", RequestConfig.SUBSTITUTION_QUERY);
    }

    @Test
    void date_query() {
        Assertions.assertEquals("/date", RequestConfig.DATE_QUERY);
    }

    @Test
    void subjectlist_query() {
        Assertions.assertEquals("/subjectlist", RequestConfig.SUBJECTLIST_QUERY);
    }

    @Test
    void class_query() {
        Assertions.assertEquals("/class", RequestConfig.CLASS_QUERY);
    }

    @Test
    void add_query() {
        Assertions.assertEquals("/add", RequestConfig.ADD_QUERY);
    }

    @Test
    void remove_query() {
        Assertions.assertEquals("/remove", RequestConfig.REMOVE_QUERY);
    }

    @Test
    void average_query() {
        Assertions.assertEquals("/average", RequestConfig.AVERAGE_QUERY);
    }
}